%ext ck5

#ARMAGEDDON APP 1.2 05/25/20

##MISC##

%patchfile $20CD7 CK5LOAD.BIN

#Play music for terminator text and title screen
%patch $4EAC $B8 $000DW $50 $9A $06B92083RL $83 $C4 $02 $90 $90 $90 $90 $90 $90 #level 13 song
%patch $1DC0C $06B9204ERL #stops intro song once main menu is called

#Game Over BMP
%patch $F818 $0001W #Y Position
%patch $F81C $0001W #X Position

#Disable star wars story Free: 1FDEo-2003B
%patch $3CB7 $04CBW

#keen pogos same height in easy as normal and hard
%patch $B97D $EB

#Conveyor belt speeds - standing
%patch $C60F $BA $0010W  $F7 $EA $90
%patch $C638     $FFF0W

#Conveyor belt speeds - walking
%patch $C6CD $BA $0010W  $F7 $EA $90
%patch $C6F1     $FFF0W

#Game Over + Ending Music
%patch $F808 $001AW #Game over (26)
%patch $EC67 $0019W #Ending sequence (25)

#No music in help menu
%patch $EABC $EB $0A

#Keen has door invincibility when going through keycard doors
%patch $AD6C $BC39W $009BW $EB $61

##CHEATS/HOUSEKEEPING!!##

#Compact left\right Keen spawn Free: EE96-EEBA
%patch $EEBB $B8 $0001W $EB $03
%patch $F4C6 $016BW #Keen right uses compact spawn (At EEBB)

#Disable F9 cheat Free: 87 bytes Used: mine collision code
%patch $79F6 $EB $5C

#Disable F10-C Count objects Free: 6B90-6C13 Used up to 6BF8: High Explosive
%patch $7401 $EB $19

#Disable F10-T Sprite test Free: 390 bytes (up to 6E74) at 6CEE Used: Mylo code up to 6DF2 Winlevel Spawn up to 6E2C Winlevel Collision up to 6E54 Skybot fall collison upto 6E6C
%patch $7679 $EB $12

#Disable F10-S AND F10-V Free: 7620-7712 Used: up to 7670 Dislike tile code 7671-76B7 Dislike got code 76B8-76FE Like got code
%patch $761D $E9 $00F6W

#Disable F10-Y Show Passages Free: 77B1-77C2
%patch $77AF $EB $12

#Disable F10-Z Suicide cheat Free: 77CB-77E4
%patch $77C3 $33 $C0 $5F $5E $8B $E5 $5D $CB

#Disable F10-B Border Colour Free: 736C-7400 Used: Air spawning upto 73A6 Space after this unstable, all cheats to freeze if used
%patch $7369 $E9 $0095W

#Disable F10-I (Space unstable, cheats freeze)
%patch $74D4 $EB

#Disable F10 + M Free: 6C14-6CED Used: Air collision to 6C74, Korath Collison to 6CB9
%patch $7590 $EB

#Disable Keen 5 F10-D DEMO (Frees $741E-$7453, $645B-$65EF:$05C1084BRL:UPLVL Spawn/collision, $162D6-$1631D:KE Spawn Code)
%patch $741C $EB $35

#God mode text adjustment
%patch $749E $04E5W #Text called from (Off)
%patch $74AC $04F2W #Text called from (On)

%patch $30825 "God mode OFF" $00
%patch $30832 "God mode ON" $00

#BAT CHEAT#

#Doesn't give V-cards
%patch $7848 $EB $04

#Ammo +20
%patch $783E $81 $06 $6F56W $0014W

#Text
%patch $30881 "Cheat Option!" $0A $0A
              "You just got 4" $0A
              "gems, +20 shots," $0A
              "and an extra keen!" $00

##ELEVATORS##

#First elevator start
%patch $F451 $50 $00 #V
%patch $F455 $1A $00 #H

#First elevator destination
%patch $F460 $34 $00
%patch $F464 $18 $00

#Main elevator start
%patch $F497 $34 $00
%patch $F49B $1C $00

#Main elevator destination
%patch $F4B2 $1E $00
%patch $F4B6 $1A $00

#Levels that activate the 2nd elevator
%patch $F470 $6F32W #Level 11
%patch $F477 $6F3EW #Level 17 
%patch $F47E $6F40W #Level 18 
%patch $F485 $6F42W #Level 19

##Korath Elder##

#Initiation (Normal Sitting Platform)
%patch $F09D $83 $3E $6F6CW  $03 $7E $03 $E9 $0300W  $57 $56 $9A $155A0D36RL #call spawn code at 162D6
             $83 $C4 $04 $C7 $06 $C29DW  $0001W  $E9 $02EDW

#Spawn Code = $155A0D36RL
%patch $162D6 $55 $8B $EC $33 $C0 $50 $9A $06B91DCDRL     $83 $C4 $02 $8B $1E
              $40 $9E $C7 $07 $0001W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A
              $8B $46 $08 $D3 $E0 $89 $47 $3E $89 $47 $0C $B8 $0130W  $50 $53
              $9A $090B11C4RL     $83 $C4 $04 $5D $CB

#Action code = $0130W
%patch $30470 $01BEW $01BEW $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $1FDE0000RL   $00000000L   $0130W

#Collision = $1FDE0000RL
%patch $1FDE0 $55 $8B $EC $56 $8B $76 $06 $8B $7E $08 $83 $3D $02 $74 $03 $5E $5D $CB $9A $196E0AFBRL $9A $13A014CARL $B8 $2B7BRW #check for keen
              $8A $16 $EC $6F $8E $C0 $26 $08 $16 $005AW  $8E $C0 $26 $08 $16 $002DW $33 $C0 $50 $9A
              $13A01848RL     $83 $C4 $02 $9A $1E000995RL     $B8 $0008W  $50 $B8
              $001AW  $50 $9A $1A2B106ERL     $83 $C4 $04 $83 $2E $99 $9B $D0        #D0=text1 align
              $B8 $002DW  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B $2D $0100W #0100W=pic1 align
              $50 $9A $1E000C75RL     $83 $C4 $06 $83 $06 $9D $9B $0C 
              $83 $3E $6F68W  $08 $75 $03 $B8 $3879W  $83 $3E $6F68W  $05 $75 $03 $B8 $38CEW $83 $3E $6F68W  $03 $75 $03 $B8 $32AFW #level checks
              $50 $9A $1A2B0EBBRL $83 $C4 $02 $9A $1E000A97RL     $B8 $001EW 
              $50 $9A $1F030ADFRL     $83 $C4 $02 $9A $155A08A5RL

%patch $1FE93 $9A $155A0EDCRL $9A $1A2B0F00RL #clear window
              $9A $1E000995RL     $B8 $0008W  $50 $B8 $001AW
              $50 $9A $1A2B106ERL     $83 $C4 $04 $83 $2E $99 $9B $30                #text2 align
              $B8 $005AW  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B $2D $0000W #pic2 align
              $50 $9A $1E000C75RL     $83 $C4 $06 $83 $06 $9D $9B $0C 
              $83 $3E $6F68W  $08 $75 $03 $B8 $327EW  $83 $3E $6F68W  $05 $75 $03 $B8 $32A1W $83 $3E $6F68W  $03 $75 $03 $B8 $38FFW #level checks
              $50 $9A $1A2B0EBBRL $83 $C4 $02 $9A $1E000A97RL     $B8 $001EW
              $50 $9A $1F030ADFRL     $83 $C4 $02 $9A $155A08A5RL     $9A $155A0EDCRL
              $9A $13A014EARL $9A $174E0D56RL $C7 $44 $1C $133EW $5E $5D $CB

%patch $33BB9 "Invisible Platforms in" $0A " space will cause the" $0A "stars behind them to" $0A "appear to twinkle" $00
%patch $33C0E "Unused Keycards can be" $0A "carried to the next level" $00
%patch $33C3F "I should have signed" $0A "with Sega..." $00

%patch $335BE "Moustaches went out" $0A "in the 80s bro" $00
%patch $335E1 "Good to know" $00
%patch $335EF "This dialogue is the" $0A "IP of Zenimax Media" $0A "and has been removed." $00

##WIN LEVEL/AIR SPRITES##

#Pointers to new sprites
%patch $F59C $0146W #Air (At $EE96)
%patch $F59E $014FW #Winlevel (At $EE9F)

#Air sprite spawn 1 (Goes to end of spawn 2)
%patch $EE96 $57 $56 $9A $06B907DCRL    $EB $07

#Winlevel sprite spawn 2 both cache $0117
%patch $EE9F $57 $56 $9A $06B90263RL     $83 $C4 $04 $B8 $2B7BRW  $8A $16
             $EC $6F $8E $C0 $26 $08 $16 $0117W  $E9 $04EDW

#Winlevel spawning code = $06B90263RL
%patch $6DF3 $55 $8B $EC $33 $C0 $50 $9A $06B91DCDRL     $83 $C4 $02 $8B $1E
             $40 $9E $C7 $07 $0001W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A
             $8B $46 $08 $D3 $E0 $89 $47 $3E $89 $47 $0C $B8 $0110W  $50 $53
             $9A $090B11C4RL     $83 $C4 $04 $5D $CB

#Winlevel action = $0110
%patch $30450 $0117W $0117W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $06B9029DRL   $090B17B5RL   $0110W

#Winlevel collision: mark previous level as done and set level state to win level = $06B9029DRL
%patch $6E2D $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $81 $7C $1C $0888W
             $75 $12 $8B $1E $55 $9E $D1 $E3 $C7 $87 $6F1AW  $0001W  $C7 $06
             $6F70W  $0002W $5F $5E $5D $CB

#Air spawning code = $06B907DCRL
%patch $736C $55 $8B $EC $33 $C0 $50 $9A $06B91DCDRL     $83 $C4 $02 $8B $1E
             $40 $9E $C7 $07 $0001W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A
             $8B $46 $08 $D3 $E0 $89 $47 $3E $89 $47 $0C $B8 $00F2W  $50 $53
             $9A $090B11C4RL     $83 $C4 $04 $5D $CB

#Air action = $00F2
%patch $30432 $0117W $0117W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $06B90084RL   $090B17B5RL   $00F2W

#Air collision = $06B90084RL
%patch $6C14  $55 $8B $EC $56 $8B $76 $08 $83 $3C $03 $74 $03 $5E $5D $CB                                #check for Keen's shot
              $B8 $0006W  $50 $B8 $0014W $50 $9A $1A2B106ERL $83 $C4 $04 $83 $06 $9D $9B $02 $B8 $37D6W  #Draw window, call text
              $50 $9A $1A2B0EBBRL $83 $C4 $02 $9A $1E000A97RL $B8 $001EW $50 $9A $1F030ADFRL $83 $C4 $02 #wait
              $9A $155A08A5RL $9A $155A0EDCRL                                                            #keypress
              $9A $174E0D56RL $56 $9A $0CCB10B3RL $83 $C4 $02 $9A $0AAF1517RL $5E $5D $CB                #clear screen, shot smash, death code

%patch $33B16 "Whoops!" $0A "You hit an air generator!" $0A "The vacuum of space" $0A "rushes in..." $00

#UPLEVEL# (Laser Right)

#Laser Right initiation (now up level)
%patch $F17E $83 $3E $6F6CW  $03 $7D $03 $E9 $021FW  $83 $3E $6F6CW  $02 $7D
             $03 $E9 $0215W  $B8 $0001W  $50 $57 $56 $9A $05C1084BRL $83 $C4
             $06 $C7 $06 $C27DW  $0001W  $E9 $01FEW

#Uplevel spawning code = $05C1084BRL
%patch $645B $55 $8B $EC $33 $C0 $50 $9A $06B91DCDRL     $83 $C4 $02 $8B $1E
             $40 $9E $C7 $07 $0001W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A
             $8B $46 $08 $D3 $E0 $89 $47 $3E $89 $47 $0C $B8 $1982W  $50 $53
             $9A $090B11C4RL     $83 $C4 $04 $5D $CB

#Uplevel action = $1982W
%patch $31CC2 $0117W $0117W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $05C10885RL   $090B17B5RL   $1982W

#Uplevel collision: increment curr_lev and set level state to restart level = $05C10885RL
%patch $6495 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $81 $7C $1C $0888W
             $75 $0A $FF $06 $6F68W  $C7 $06 $6F70W  $0003W  $5F $5E $5D $CB

##SCORE##

#Disable EGAGRAPH check in Keen 5 (Frees 389 bytes at $3CF0)
%patch $3CDF $90 $90

#Reset Keen's score when he dies (Use levels 15 & 16 done variables)
%patch $3CF0 $55 $8B $EC $56 $8B $76 $06 $A1 $6F3AW  $A3 $6F4EW
                 $A1 $6F3CW  $A3 $6F50W  $5E $5D $CB

#Store Keen's score on level load
%patch $699E $A1 $6F4EW  $A3 $6F3AW  $A1 $6F50W  $A3 $6F3CW $EB $42

#Call reset Keen's score on death
%patch $66E2 $9A $037D0520RL     $BF $0001W  $EB $06

#Track stored score in STATUS WINDOW (replaces extra keen at score)
%patch $7DE7 $6F3AW #Score (low)
%patch $7DE3 $6F3CW #Score (high)

#Replace EXTRA text to SCORE (status window)
%patch $308E2 "SCORE" $00

#Replace SCORE text to PENDING (status window)
%patch $7D63 $1919W #Text read from
%patch $31C59 "PENDING" $00

#1UP item gives 20000 points, no extra life
%patch $C100 $90 $90 $90 $90 #keen's collision with 1up sprite type blanked
%patch $31628 $4E20W #1UP item give 20000 points
%patch $3160E $0008W #sound


#LIKES/DISLIKES (Vitalin)

#Like code calls new like got code location
%patch $C381 $06B90B28RL

#After 1up likes set to 10
%patch $C398 $000AW

#Dislike code: each item got -1 vitalin, if vitalin=0, kill keen
%patch $7620 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $B8 $0001W  $50 $50
             $57 $56 $50 $1E $B8 $1308W  $50 $9A $174E0F25RL     $83 $C4 $0E
             $B8 $0031W  $50 $9A $196E09EFRL     $83 $C4 $02 $57 $56 $9A       #play sound 31
             $06B90AE1RL $83 $C4 $04 $FF $0E $6F58W $A1 $6F58W  $3D $0000W     #call dislike got code, check if vitalin counter = 0
             $7F $0B $C7 $06 $6F58W $0000W $9A $0AAF1517RL $5F $5E $5D $CB     #If >0 jump to end of code else; set v=0 then run death code

#Dislike tile is mooning tile
#Mooning tile property code (call dislike tile code)
%patch $C50B $FF $76 $FE $57 $9A $06B90A90RL  $EB $1B

#Vitalin counter text (status window)
%patch $30917 "LIKES" $00

#Dislike got code
%patch $7671 $55 $8B $EC $B8 $0001W $50 $9A $06B91DCDRL $83 $C4 $02 $8B $1E $40 $9E $C7 $47 $06 $0000W 
             $C7 $47 $20 $0003W $C7 $07 $0001W $C7 $47 $10 $0001W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B 
             $46 $08 $D3 $E0 $89 $47 $0C $B8 $1A18W $50 $53 $9A $090B11C4RL $83 $C4 $04 $5D $CB

#Like got code
%patch $76B8 $55 $8B $EC $B8 $0001W $50 $9A $06B91DCDRL $83 $C4 $02 $8B $1E $40 $9E $C7 $47 $06 $0000W 
             $C7 $47 $20 $0003W $C7 $07 $0001W $C7 $47 $10 $FFFFW $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B 
             $46 $08 $D3 $E0 $89 $47 $0C $B8 $19DCW $50 $53 $9A $090B11C4RL $83 $C4 $04 $5D $CB

#Animation frames
%patch $31D56 $0000W

#Speed
%patch $31D28 $0000W $0008W
%patch $31D46 $0000W $0008W
%patch $31D64 $0000W $0008W
%patch $31D82 $0000W $0008W

#Animations
%patch $31D1C $00CBW $00CBW
%patch $31D26 $000AW        #Animation speed
%patch $31D3A $00CCW $00CCW
%patch $31D44 $0018W        #Animation speed
%patch $31D58 $00CDW $00CDW
%patch $31D62 $000AW        #Animation speed
%patch $31D76 $00CEW $00CEW
%patch $31D80 $0018W        #Animation speed

#Action Type
%patch $31D20 $0001W
%patch $31D3E $0001W
%patch $31D5C $0001W
%patch $31D7A $0001W

#KEYCARD

#allow collection of multiple cards (adjust keen's collision)
%patch $C122 $FF $06
%patch $C126 $90 $90

#Don't lose Keycard on starting a level
%patch $6A2B $EB $04
#But still lose card(s) on death
%patch $C025 $6F5AW #set keycard to 0 in death code instead of mooning stat

#Opening Key doors subtracts 1 card instead of setting stat directly to 0(allows for use of multiple cards)
%patch $AD12 $FF $0E
%patch $AD16 $90 $90

#Status screen keycard icon acts like a counter (so it can show if you have more than 1 card)
#Side effect: Overwrites keycard black background rectangle, hard to notice if keycard icon has black border
%patch $7E18 $A1 $6F5AW $99 $52 $50 $B8 $0019W $50 $B8 $0001W $50 $B8 $005CW $50 $B8 $0088W $50 $0E $E8 $FCFBW $EB $14
%patch $7E4A $0C

##LEVELS##

%patch $D2C2 $18 #Number of levels enterable 24
%patch $60B3 $18 $77 #highest level number is 24
%patch $60AE $10 $74 #level 16 can be re-entered

#Level names
%patch $20040 "Omegamatic" $00
              "Korath Dunes" $00
              "Korath River" $00
              "Slicestar Cavern" $00
%patch $20076 "Korath Village" $00
              "Ancient Cliffs" $00
              "Lavender Falls" $00
              "Omegamatic" $0A "Ground Station" $00
%patch $200BD "Security Checkpoint" $0A "One" $00
              "Cargo Bay `A'" $00
              "Main Engineering" $00
              "Habitat Sphere" $00
%patch $20103 "Korath III" $0A "Moon" $00
              "Korath III" $00
%patch $2011E "High Scores" $00
%patch $2012A "Korathian Mines" $00
%patch $2013A "BWB Megarocket" $00
%patch $20149 "Operations Sphere" $00
              "Hydro Sphere" $00
              "Fuel Refinery" $0A "Sphere" $00
%patch $2018D "Keen infiltrates" $0A "The Bridge" $00


#Level name pointers
%patch $31AB4 $20000040RL #0 Omegamatic
              $2000004BRL #1 Korath Dunes
              $20000058RL #2 Korath River
              $20000065RL #3 Slicestar Cavern
%patch $31AC4 $200000BDRL #4 Security Checkpoint One
              $20000085RL #5 Ancient Cliffs
              $20000094RL #6 Lavender Falls
              $200000A3RL #7 Omegamatic Ground Station
%patch $31AD4 $20000076RL #8 Korath Village
              $200000D5RL #9 Cargo Bay
              $2000012ARL #10 Korathian Mines
              $200000F4RL #11 Habitat Sphere
%patch $31AE4 $20000103RL #12 Korath Moon
              $20000113RL #13 Korath III (Map name)
              $200000E3RL #14 Main Engineering
              $2000011ERL #15 High Scores
%patch $31AF4 $2000013ARL #16 BWB Megarocket
              $20000168RL #17 Refinery Sphere
              $2000015BRL #18 Hydro Sphere
              $20000149RL #19 Operations Sphere
              $200004BERL #22 Security Checkpoint Two
              $2000048BRL #21 Research & Development Sphere
              $2000045CRL #22 Management Sphere
              $200004E7RL #23 Asteriod Belt
              $2000019ERL #24 The Bridge

#Level entry texts
%patch $201AA "Keen boards the" $0A "Omegamatic" $00
              "Keen walks across" $0A "the Korath Dunes" $00
              "Keen hops" $0A "cautiously across" $0A "Korath River" $00
              "Keen cuts through" $0A "Slicestar Cavern" $00
%patch $20234 "Keen tours" $0A "Korath Village" $00
              "Keen scales the" $0A "Ancient Cliffs" $00
              "Keen admires" $0A "Lavender Falls" $00
              "Keen barges into" $0A "the Omegamatic" $0A "Ground Station" $00
%patch $202B8 "Keen sneaks through" $0A "Security Checkpoint" $0A "One" $00
              "Keen stomps through" $0A "Cargo Bay `A'" $00
              "Keen expertly" $0A "examines" $0A "Main Engineering" $00
              "Keen rudely" $0A "intrudes the" $0A "Habitat Sphere" $00
%patch $20356 "Keen finds himself" $0A "on a Moon orbiting" $0A "Korath III" $00
              "Keen descends" $0A "into the" $0A "Korathian Mines" $00
%patch $203AF "Keen surveys the" $0A "damage to the" $0A "BWB Megarocket" $00
%patch $203DD "Keen opposes the" $0A "Operations Sphere" $00
              "Keen hijacks the" $0A "Hydro Sphere" $00
              "Keen fuels up in the" $0A "Refinery Sphere" $00              
%patch $20444 "H" $00
%patch $20446 "Keen micromanages the" $0A "Management Sphere" $00
%patch $20471 "Keen slithers through" $0A "the Research &" $0A "Development Sphere" $00
%patch $204A9 "Keen trips alarms at" $0A "Security Checkpoint" $0A "Two" $00
%patch $204D7 "Keen visits the" $0A "Asteriod Belt" $00

#Level entry pointers
%patch $31B18 $200001AARL #Omegamatic
              $200001C5RL #Korath Dunes
              $200001E8RL #Korath River
              $20000211RL #Slicestar Cavern
%patch $31B28 $200002B8RL #Security Checkpoint One
              $2000024ERL #Ancient Cliffs
              $2000026DRL #Lavender Falls
              $20000289RL #Omegamatic Ground Station
%patch $31B38 $20000234RL #Korath Village
              $200002E4RL #Cargo Bay A
              $20000387RL #Korathian Mines
              $2000032ERL #Habitat Sphere
%patch $31B48 $20000356RL #Korath Moon
              $20000387RL #unused (Lvl 13 Korath III)
              $20000306RL #Main Engineering
              $20000444RL #High Scores
%patch $31B58 $200003AFRL #BWB
              $2000041ERL #Refinery Sphere
              $20000400RL #Hyrdo Sphere
              $200003DDRL #Operations Sphere
%patch $31B68 $200004A9RL #Security Checkpoint Two
              $20000471RL #R&D Sphere
              $20000446RL #Management Sphere
              $200004D7RL #Asteriod Belt
              $2000018DRL #The Bridge
              
#When Keen is on Korath III
%patch $6210  $65    #Vertical location for different entrance text
%patch $6214  $0223W #Text called from
%patch $30563 "Keen steps out" $0A "onto Korath III" $00
%patch $7CE8  $65    #vertical location for different level name

##DESTROYING MULTIPLE QED'S (IN SEPERATE LEVELS) WINS GAME##
#QEDs represent wifi generators, unused k5 stat replaces normal QED stat
#This patch uses 286 instructions; not compatible with 8086 or 8088 CPUs
#Safe for use with Dosbox

#QED appears on all levels
%patch $F10C $90 $90

#Number of QEDs that need to be destroyed
%patch $F110 $6F5CW $0006W #set to > than amount in game, otherwise seems to mess things up

#QED Spawn includes health
%patch $139B4 $C7 $47 $40 $0005W

#QED collision
%patch $9E88 $55 $8B $EC $56 $8B $76 $08 $83 $3C $03 $74 $03 $5E $5D $CB $B8
             $1EB2W  $50 $56 $9A $090B1242RL     $83 $C4 $04 $C7 $44 $00 $0000W
                 $8B $76 $06 $FF $4C $40 $74 $03 $5E $5D $CB $FF $74 $2E $FF
             $74 $2C $9A $0F920628RL     $83 $C4 $04 $FF $74 $2E $FF $74 $30
             $9A $0F920628RL     $83 $C4 $04 $FF $74 $32 $FF $74 $2C $9A $0F920628RL
                         $83 $C4 $04 $FF $74 $32 $FF $74 $30 $9A $0F920628RL
                 $83 $C4 $04 $68 $0003W  $68 $0003W  $FF $74 $2E $FF $74 $2C
             $68 $0001W  $FF $36 $9E51W  $68 $0020W  $9A $174E0F25RL    $83
             $C4 $0E $56 $9A $06B91E47RL    $44 $44 $FF $0E $6F5CW  $76 $03 #use new variable
             $90 $90 $90 $9A $0F920677RL    $5E $5D $CB                     #always spawn win level sprite

#New QED action uses collision
%patch $334C6 $FFFFW $FFFFW $0000W $0000W $0001W $0008W $0080W $0000W
              $00000000L    $090B0DD8RL   $00000000L    $3186W

#Win level sprite behaviour call (moved to Korath stock collision location for more space)
%patch $31E90 $11C41D16RL

#Win level sprite new behaviour code
%patch $13956 $55 $8B $EC $81 $3E $6F50W $0015W $7C $06 $C7 $06 $C17BW $0001W #Check SCORE if less than x jump, else set mooning stat=1
              $83 $3E $9E55W $18 $75 $08 $C7 $06 $6F70W $000FW $5D $CB $C7 $06 $6F70W $000EW $5D $CB #Level=24=win game, else fuse message 

##FUSE MESSAGE CODE: 4 UNIQUE MESSAGES##
%patch $F844 $55 $8B $EC $9A $196E0AFBRL     $9A $13A014CARL     $B8 $2B7BRW
             $8A $16 $EC $6F $8E $C0 $26 $08 $16 $005AW  $8E $C0 $26 $08 $16
             $005BW  $33 $C0 $50 $9A $13A01848RL     $83 $C4 $02 $9A $1E000995RL
                     $B8 $0008W  $50 $B8 $001AW  $50 $9A $1A2B106ERL     $83
             $C4 $04 $83 $2E $99 $9B $30 $B8 $005AW  $50 $FF $36 $46 $9E $A1
             $9B $9B $03 $06 $99 $9B $50 $9A $1E000C75RL     $83 $C4 $06 $83
             $06 $9D $9B $0C $83 $3E $6F68W  $11 $74 $1D $83 $3E $6F68W  $12
             $74 $11 $83 $3E $6F68W $13 $74 $05 $B8 $18BBW  $EB $0D $B8 $18CEW  $EB $08 $B8 $044EW  $EB $03 $B8  $3750W $50
             $9A $1A2B0EBBRL     $83 $C4 $02 $9A $1E000A97RL $9A $155A08A5RL 
             $9A $155A0EDCRL     $B8 $005BW  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06
             $99 $9B $50 $9A $1E000C75RL     $83 $C4 $06 $9A $1E000A97RL
             $9A $155A08A5RL     $9A $155A0EDCRL     $9A $13A014EARL     $9A
             $06B9204ERL     $5D $CB


#Messages
%patch $31BFB "Enjoy 240p Shikadi" $00

%patch $31C0E "One of the signal" $0A "generators powering the" $0A "Shikadi's Wifi network" $0A "is toast!" $00

%patch $3078E  "Imma make Shikadi" $0A
               "dial up like its 1995" $00

%patch $33A90  "Connection trouble?" $0A
               "I feel bad for ya son" $0A
               "I got 99 problems" $0A
               "but bitrate ain't one" $00

#Special Ending
%patch $EC2F $83 $3E $C17BW $01 $75 $12
#The special ending trigger must be used in conjuction with my modified Win level sprite behaviour which sets mooning stat to 1 if score exceeds 80% of perfect
#Death code must be patched so that mooning stat is not messed with when dying (this was done in my Keycard patch)
#Must also patch mooning stat not to set to 0 on level start
#At end of game it checks if mooning stat is 1 and if so triggers special ending

#Do not set mooning stat to 0 on level start
%patch $C407 $EB $0B

#High Scores
%patch $33D56 "                 " $00
%patch $33D96 "                 " $00
%patch $33DD6 "                 " $00
%patch $33E16 "                 " $00
%patch $33E56 "                 " $00
%patch $33E96 " Goodbye Galaxy  " $00
%patch $33ED6 "    Rebooted     " $00
%patch $33F16 " 55Aavenue 2020  " $00

#Condensing errors for text space
%patch $17896  $37A2W #Text called from
%patch $33AE2 "BG anim of 0" $00

%patch $17906  $37AFW #Text called from
%patch $33AEF "TMU animating tiles" $00

%patch $17992  $37C5W #Text called from
%patch $33B05 "Unending BG anim" $00

%patch $8CA2  $0617W #Text called from
%patch $30957 "No memory for music" $00
              
%patch $89E5  $065EW #Text called from
%patch $3099E "Tried to remove player" $00

%patch $18BB8  $3921W #Text called from
%patch $33C61 "Sprtarry=nospots" $00

%patch $33C80 "Uncached Sprite!" $00

%patch $17A5E  $3932W #Text called from
%patch $33C72 "FG anim0" $00

%patch $17B63  $3951W #Text called from
%patch $33C91 "Unending FG anim" $00

##Ryba## (Spindred)

#Spindred sticks to floors and ceilings
%patch $12A65 $FFF8W #Small floor jump height
%patch $12A18 $0008W #Small ceiling jump height

#Number of roof bounces before going to floor:
%patch $129E5 $0A

#Number of floor bounces before going to roof:
%patch $12A32 $1E

%patch $12A09 $EB $0A #Don't play Spindred small ceiling bounce sound
%patch $12A56 $EB $0A #Don't play Spindred small floor bounce sound
%patch $129FB $EB $0A #Don't play Spindred slam into ground from roof sound

##Shelley##

#Smashed Shelley fragments do not vanish
%patch $32916 $BA $25
%patch $32934 $D8 $25

##Propane Tanks## (Shikadi Mine)

#Give Mine a foreground value (overwrite clipping)
%patch $11C5D $C7 $47 $20 $0003W

#Spawn Y position
%patch $11C72 $FDC2W

#Stop Mine moving
%patch $11D1B $90 $90

#Don't show Mine's eye
%patch $12572 $5E $5D $CB

#When in-range (stop mine from detonating when near/touching keen)
%patch $12187 $2644W #When near Keen vertically
%patch $122A6 $2644W #When near Keen horizontally

#Make shikadi mine use custom collision code until it explodes
%patch $3295C $06B90E68RL #Shikadi mine sit
%patch $3297A $06B90E68RL #Shikadi mine move
%patch $32998 $06B90E68RL #Shikadi mine change direction
%patch $329B6 $00000000L #Shikadi mine explode
%patch $329D4 $00000000L #Shikadi mine
%patch $329F2 $00000000L #Shikadi mine
%patch $32A10 $00000000L #Shikadi mine (Explodes here)

#Shikadi Mine custom collision code: explodes when shot by keen or enemy (Overwrites boss cheat)
%patch $79F8 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $04 $74 $05 $83 $3D $03 $75 $0E
             $B8 $2662W $50 $57 $56 $9A $090B16CDRL $83 $C4 $06 $5F $5E $5D $CB

#Shikadi mine explode animation speed
%patch $329AC $0006W
%patch $329CA $0006W        
%patch $329E8 $0006W        
%patch $32A06 $0006W

##Armageddon Core## (Sitting platform)

#Sprite Type
%patch $10620 $01

#Tile Interaction
%patch $31F6A $00000000L

#Collision
%patch $31F66 $06B90000RL

#Collision code
%patch $6B90 $55 $8B $EC $56 $8B $76 $08 $83 $3C $03 $74 $03 $5E $5D $CB                                 #check for keen's shot
             $9A $1E000995RL $B8 $0002W  $50 $B8 $000CW  $50 $9A $1A2B106ERL                             #set window size
             $83 $C4 $02 $B8 $049DW  $50 $9A $1A2B0E1DRL $83 $C4 $02                                     #Call text, centre
             $9A $1E000A97RL $B8 $001EW $50 $9A $1F030ADFRL $83 $C4 $02 $9A $155A08A5RL $9A $155A0EDCRL  #Wait, keypress
             $9A $174E0D56RL $56 $9A $0CCB10B3RL $83 $C4 $02 $C7 $06 $6F6AW $0000W $C7 $06 $6F70W $0001W $5F $5E $5D $CB    

%patch $307DD "Oops..." $00

##Korath##

#Collision
#Walk
%patch $33426 $06B900E5RL
%patch $33444 $06B900E5RL
%patch $33462 $06B900E5RL
%patch $33480 $06B900E5RL
#Sit
%patch $3349E $06B900E5RL

#Collision Code
%patch $6C75 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $3C $02 $75 $19 #check for Keen
             $8B $5C $1C $8B $47 $14 $0B $47 $16 $74 $0E $57 $56 $9A         #Push Keen
             $090B0CD2RL     $83 $C4 $04 $5F $5E $5D $CB                     #Push Keen
             $83 $3C $03 $74 $05 $83 $3C $04 $75 $0E                         #check for keen or enemy shot
             $B8 $3168W  $50 $56 $57 $9A $090B16CDRL $83 $C4 $06 $5F $5E $5D $CB #Be stunned
#default korath collision space used for new win level behaviour code

#Easy Still Platform spawns hard mode Korath
%patch $F0BA $83 $3E $6F6CW  $03 $7D $03 $E9 $02E3W $57 $56 $9A $11C41C81RL 
       $83 $C4 $04 $C7 $06 $C2A3W  $0001W  $E9 $02D0W

##Spike## (Spirogrip)

#Spirogrip spawned searching
%patch $127DC $2914W 

#Spirogrip Move Down
%patch $32D50 $0000W $0050W

#Spirogrip Move Left Down
%patch $32D6E $FFA0W $0027W
#Backs away
%patch $32BAC $0000W $0000W
%patch $32BCA $0010W $FFF0W

#Spirogrip Move Right Down
%patch $32D8C $0050W $0027W
#Backs away
%patch $32BE8 $0000W $0000W
%patch $32C06 $FFF0W $FFF0W

#Spirogrip Move Up
%patch $32DAA $0000W $FFA0W

##Mylo## (Sneaky Platform)

#Wait behaviour
%patch $320F4 $00000000L

#Sprite type
%patch $10E05 $01

#Collision
%patch $320F8 $06B9015ERL

#Tile interaction
%patch $320FC $00000000L #wait
%patch $3211A $00000000L #flee
%patch $32138 $00000000L #return

#Animations
#Platform flee
%patch $32102 $0000W $0000W
%patch $3210C $0900W #time
#Platform return
%patch $32120 $0000W $0000W
%patch $3212A $0900W #time

#Collision code
%patch $6CEE  $55 $8B $EC $9A $196E0AFBRL     $9A $13A014CARL $B8 $2B7BRW
              $8A $16 $EC $6F $8E $C0 $26 $08 $16 $005AW  $8E $C0 $26 $08 $16 $0041W $33 $C0 $50 $9A
              $13A01848RL     $83 $C4 $02 $9A $1E000995RL     $B8 $0008W  $50 $B8
              $001AW  $50 $9A $1A2B106ERL     $83 $C4 $04 $83 $2E $99 $9B $D0        #D0=text1 align
              $B8 $0041W  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B $2D $0100W #0100W=pic1 align
              $50 $9A $1E000C75RL     $83 $C4 $06 $83 $06 $9D $9B $0C $B8 $0428W
              $50 $9A $1A2B0EBBRL $83 $C4 $02 $9A $1E000A97RL     $B8 $001EW 
              $50 $9A $1F030ADFRL     $83 $C4 $02 $9A $155A08A5RL
  
%patch $6D77  $9A $155A0EDCRL $9A $1A2B0F00RL #clear window
              $9A $1E000995RL     $B8 $0008W  $50 $B8 $001AW
              $50 $9A $1A2B106ERL     $83 $C4 $04 $83 $2E $99 $9B $30                #text2 align
              $B8 $005AW  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B $2D $0000W #pic2 align
              $50 $9A $1E000C75RL     $83 $C4 $06 $83 $06 $9D $9B $0C $B8 $3819W
              $50 $9A $1A2B0EBBRL $83 $C4 $02 $9A $1E000A97RL     $B8 $001EW
              $50 $9A $1F030ADFRL     $83 $C4 $02 $9A $155A08A5RL     $9A $155A0EDCRL
              $9A $13A014EARL $9A $174E0D56RL $C7 $44 $1C $1DE0W $5D $CB

%patch $30768 "Power steering is on" $0A "the fritz again." $00
%patch $33B59 "Ugh..." $0A "Everything has to be a" $0A "shared universe now." $0A "Thanks a lot Marvel." $00

##Robopest## (Sphereful)

#Sphereful Behaviors
%patch $3338A $11C41A21RL #Flying
%patch $333A8 $11C41A21RL
%patch $333C6 $11C41A21RL 
%patch $333E4 $090B1710RL #Falling (Fall1)

#When spawned
%patch $13653 $303AW 

#Actions
%patch $33396 $3058W #Fly 1
%patch $333B4 $3076W #Fly 2
%patch $333D2 $303AW #Fly 3
%patch $333F0 $0B94W #Fall

#Animation Speed
%patch $333D4 $0169W $0169W #Fall
%patch $333DE $0400W

#Behaviour
#Flying
#11C41A21RL
%patch $13661 $55 $8B $EC $56 $8B $76 $06 $9A $1DFB0036RL     $3B $06 $9BB4W
              $73 $08 $8B $44 $0E $F7 $D8 $89 $44 $0E $83 $7C $10 $FF $75 $10
              $9A $1DFB0036RL     $3B $06 $9BB4W  $73 $05 $C7 $44 $10 $0001W
              $9A $1DFB0036RL     $3D $0020W  $7D $18
              $8B $44 $0C $8B $1E $9E3EW  $3B $47 $0C $76 $07 $C7 $44 $10 $FFFFW 
              $EB $05 $C7 $44 $10 $0001W $B8 $0014W 
              $50 $FF $74 $0E $56 $9A $090B14D7RL     $83 $C4 $06 $B8 $0014W 
              $50 $FF $74 $10 $56 $9A $090B154FRL     $83 $C4 $06 $5E $5D $CB

%patch $1364D $C7 $47 $0E $0001W
%patch $1362E $C7 $47 $10 $0001W

%patch $137AC $5F $5E $8B $E5 $5D $CB #don't draw diamonds

#Collision
%patch $3338E $11C41B72RL #Flying
%patch $333AC $11C41B72RL
%patch $333CA $11C41B72RL 
%patch $333E8 $06B902C5RL #Falling

#Flying Collision
#11C41B72RL
%patch $137B2 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0AAF1517RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E
              $B8 $3094W  $50 $57 $56 $9A $090B16CDRL $83 $C4 $06 $5F $5E $5D $CB

#Falling Collision: Block shots only
#06B902C5RL
%patch $6E55 $55 $8B $EC $56 $8B $76 $08 $83 $3C $03 $75 $09 $56 $9A $0CCB10B3RL $83 $C4 $02 $5E $5D $CB

#Tile Interaction
%patch $333EC $0F920119RL #Fall (use shelley Fragments interaction)

#Don't play Sphereful sounds
%patch $13723 $EB $0A #Sphereful hit walls
%patch $1373D $EB $0A #Sphereful hit ceiling
%patch $13783 $EB $0A #Sphereful hit floor

#Stunned sphereful action after hitting ground = $0B94W (overwrite defunct keen dead action)
%patch $30ED4 $0169W $0169W $0003W $0000W $0000W $0100W $0000W $0000W
              $00000000L   $06B902C5RL   $0F920119RL   $303AW

##SHIKADI POLE SPARKS##
#Sparks keep going until end of pole (don't stop in pole holes)
%patch $1316A $00 $75 #jump if tile MiscFlag value DOES NOT equal $00

#-------------------------------------------------------------------------------
# Customized Screen Update Code For KEEN5 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# What does this patch script do? Well, it fixes a few minor glitches when
# playing COMMANDER KEEN 4-6 in DOSBox, such as:
#
# - jerky scrolling
# - sprites becoming invisible for one frame
# - sprites hidden behind foreground tiles becoming visible
#
# Changing the "Fix Jerky Motion" option in the options menu will change the
# behavior of the screen update code. This option should be turned OFF (which
# is the default setting) when playing in DOSBox.
#
# I also tested this code on various old PCs, using an MS-DOS 6.22 boot disk and
# running the game directly from DOS, and only one of them had problems with the
# default setting. That machine was a "Texas Instruments TravelMate 4000E 486
# WinSX/25MHz Color" system. Enabling the "Fix Jerky Motion" option fixed the
# problems on that machine.
#
# Note that this code has NOT been tested on an actual EGA card. The WaitVBL
# code was designed to stop waiting for a VBL when more than 1/70th of a second
# has passed since the code started to wait for a VBL. That's because the code
# can miss the VBL if the CPU was hadling an interrupt while the VBL signal was
# present and therefore the WaitVBL code didn't get to "see" the VBL signal.
# But EGA cards use a refresh rate of 60 Hz, not 70 Hz like the (S)VGA cards.
# That means it is possible for the WaitVBL code to exit a little too early on
# systems equipped with an EGA card, which means the issues listed above could
# still pop up.
#-------------------------------------------------------------------------------
#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1F795
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $6F12w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $6FDEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $6F12w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1F816
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $9BA5w		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $9BA5w		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn
#-------------------------------------------------------------------------------

#!# PATCHES BELOW THIS POINT GENERATED COURTESY OF ABIATHAR #!#

# Graphics files (EGA resources)
%egahead egahead.ck5

# Map files
%maphead MAPHEAD.CK5

# Audio files
%patchfile $21C80 AUDIOHED.CK5
%patchfile $35EC4 AUDIODCT.CK5

# Number of entries in the music mapping table
%patch $8C20 $1B
# The music mapping table
%patch $3067A $0018W
              $0012W
              $0014W
              $0015W
              $0011W
              $0016W
              $0017W
              $0019W
              $000CW
              $001AW
              $0008W
              $0006W
              $000AW
              $000EW
              $0009W
              $000FW
              $0013W
              $000DW
              $0003W
              $0001W
              $000BW
              $0005W
              $0010W
              $0007W
              $0002W
              $0000W
              $0004W
# Updated boundary between digitized sounds and IMF songs
%patch $8C61 $00B3W
# Number of IMF songs
%patch $8C0D $1B
# Updated pointers to the start of the song chunks
%patch $8BF1 $BF2BW
%patch $8BFF $BF2BW
%patch $8CF5 $BF2BW

# Tileinfo file
%patchfile $25B22 KEEN5.TLI

%end